#ifndef _ELEVEL_H_
#define _ELEVEL_H_


#include "types.h"

#define DLLVERSION	0x0001


typedef u32 (WINAPI *ELEVELVERSION)();
extern ELEVELVERSION ELevelVersion;
//  returns the elevel.dll version number


typedef u32 (WINAPI *ELEVELDECMP)(u8 *src, u8 *dest);
extern ELEVELDECMP ELevelDecmp;
//  decompresses the src data to dest
//  returns total number of bytes decompressed
//  src and dest must be pointers to allocated memory
//  if not enough memory is allocated, you will crash it ;)


typedef u32 (WINAPI *ELEVELGETDECMPSIZE)(u8 *src);
extern ELEVELGETDECMPSIZE ELevelGetDecmpSize;
//  returns the total size of decompressed data
//  src must be a pointer to the compressed elevel data


#endif //_ELEVEL_H_
